;*****************************************************************************
; Calculate sinus_gel & cosinus_gel for EOS ( uses coprocessor )
; coded by mOtzEl / cRyOGeN^sUSPENd
;
; Ostatnia aktualizacja : 23.12.97
;*****************************************************************************

;*****************************************************************************
; Calculate sinus_gel & cosinus_gel  ( wykorzystuje koprocha !!! )
; Zalozenia :
;   zdefiniowane tablice sinus_gel i cosinus_gel ( dw )
;*****************************************************************************
NUMBER_GEL      EQU 256                         ; ile pozycji w tablicy
MULT_GEL        EQU 22 ;15                      ; mnoznik tablicy sinus_gela & cosinus_gela

Calculate_sincos_gel     Proc
        mov     edi, o sinus_gel
        mov     ecx, NUMBER_GEL             ; ile pozycji w tablicy
        mov     edx, 0                  ; 0 to liczy sinus_gela else cosinus_gela
        finit
pet_sin_gel:
        mov     temp_s_gel, NUMBER_GEL
        sub     temp_s_gel, cx
        fldpi                           ; zaladuj PI na stos
        fimul   temp_s_gel                  ; x * PI
        mov     temp_s_gel, NUMBER_GEL / 2
        fidiv   temp_s_gel                  ; ( x * PI ) / (NUMBER_GEL / 2)
        cmp     edx, 0
        jne     cosin
        fsin                            ; sin( ( x * PI ) / ( NUMBER_GEL / 2 ) )
        jmp     sin
cosin:  fcos                            ; cos( ( x * PI ) / ( NUMBER_GEL / 2 ) )
sin:
        mov     temp_s_gel, MULT_GEL
        fimul   temp_s_gel                  ; MULT_GEL * sin( (x*PI) / (NUMBER_GEL / 2))
        frndint                         ; zaokraglij do liczby calkowitej
        fistp   w temp_s_gel
        mov     ax, temp_s_gel              ; zapisz wynik do eax
        stosw                           ; zapamietaj w tablicy

        dec     ecx                     ; zmniejsz liczbe petli
        jnz     pet_sin_gel
        inc     edx
        mov     edi, o cosinus_gel
        mov     ecx, NUMBER_GEL
        cmp     edx, 1                      ; jesli sinus_gel jest obliczony to
        jng     pet_sin_gel                 ; licz cosinus_gel
        ret

sinus_gel           dw 256 dup (?)          ; sinus * 25
cosinus_gel         dw 256 dup (?)          ; cosinus * 25
temp_s_gel          dw 0

Calculate_sincos_gel endp

